org.apache.sling.commons.html.internal

## Class DOMBuilder

- java.lang.Object
- - org.apache.sling.commons.html.internal.DOMBuilder

All Implemented Interfaces:
  ContentHandler, LexicalHandler

    public class DOMBuilder
    extends Object
    implements ContentHandler, LexicalHandler

The `DOMBuilder` is a utility class that will generate a W3C DOM Document from SAX events.

### Constructor Summary

Constructors
Constructor and Description
`DOMBuilder()` Construct a new instance of this DOMBuilder.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `characters(char[] ch, int start, int length)`
`void` `comment(char[] ch, int start, int length)`
`void` `endCDATA()`
`void` `endDocument()`
`void` `endDTD()`
`void` `endElement(String uri, String localName, String qName)`
`void` `endEntity(String name)`
`void` `endPrefixMapping(String prefix)`
`Document` `getDocument()`
`void` `ignorableWhitespace(char[] ch, int start, int length)`
`void` `processingInstruction(String target, String data)`
`void` `setDocumentLocator(Locator locator)`
`void` `skippedEntity(String name)`
`void` `startCDATA()`
`void` `startDocument()`
`void` `startDTD(String name, String publicId, String systemId)`
`void` `startElement(String uri, String localName, String qName, Attributes atts)`
`void` `startEntity(String name)`
`void` `startPrefixMapping(String prefix, String uri)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### DOMBuilder

    public DOMBuilder()
               throws IOException

Construct a new instance of this DOMBuilder.

Throws:
  `IOException` - If for some reason the `TransformerHandler` cannot be created.

### Method Detail

#### getDocument

    public Document getDocument()

Returns:
  The newly built `Document` or `null`.

#### setDocumentLocator

    public void setDocumentLocator(Locator locator)

Specified by:
  `setDocumentLocator` in interface `ContentHandler`

#### startDocument

    public void startDocument()
                       throws SAXException

Specified by:
  `startDocument` in interface `ContentHandler`
Throws:
  `SAXException`

#### endDocument

    public void endDocument()
                     throws SAXException

Specified by:
  `endDocument` in interface `ContentHandler`
Throws:
  `SAXException`

#### startPrefixMapping

    public void startPrefixMapping(String prefix,
                                   String uri)
                            throws SAXException

Specified by:
  `startPrefixMapping` in interface `ContentHandler`
Throws:
  `SAXException`

#### endPrefixMapping

    public void endPrefixMapping(String prefix)
                          throws SAXException

Specified by:
  `endPrefixMapping` in interface `ContentHandler`
Throws:
  `SAXException`

#### startElement

    public void startElement(String uri,
                             String localName,
                             String qName,
                             Attributes atts)
                      throws SAXException

Specified by:
  `startElement` in interface `ContentHandler`
Throws:
  `SAXException`

#### endElement

    public void endElement(String uri,
                           String localName,
                           String qName)
                    throws SAXException

Specified by:
  `endElement` in interface `ContentHandler`
Throws:
  `SAXException`

#### characters

    public void characters(char[] ch,
                           int start,
                           int length)
                    throws SAXException

Specified by:
  `characters` in interface `ContentHandler`
Throws:
  `SAXException`

#### ignorableWhitespace

    public void ignorableWhitespace(char[] ch,
                                    int start,
                                    int length)
                             throws SAXException

Specified by:
  `ignorableWhitespace` in interface `ContentHandler`
Throws:
  `SAXException`

#### processingInstruction

    public void processingInstruction(String target,
                                      String data)
                               throws SAXException

Specified by:
  `processingInstruction` in interface `ContentHandler`
Throws:
  `SAXException`

#### skippedEntity

    public void skippedEntity(String name)
                       throws SAXException

Specified by:
  `skippedEntity` in interface `ContentHandler`
Throws:
  `SAXException`

#### startDTD

    public void startDTD(String name,
                         String publicId,
                         String systemId)
                  throws SAXException

Specified by:
  `startDTD` in interface `LexicalHandler`
Throws:
  `SAXException`

#### endDTD

    public void endDTD()
                throws SAXException

Specified by:
  `endDTD` in interface `LexicalHandler`
Throws:
  `SAXException`

#### startEntity

    public void startEntity(String name)
                     throws SAXException

Specified by:
  `startEntity` in interface `LexicalHandler`
Throws:
  `SAXException`

#### endEntity

    public void endEntity(String name)
                   throws SAXException

Specified by:
  `endEntity` in interface `LexicalHandler`
Throws:
  `SAXException`

#### startCDATA

    public void startCDATA()
                    throws SAXException

Specified by:
  `startCDATA` in interface `LexicalHandler`
Throws:
  `SAXException`

#### endCDATA

    public void endCDATA()
                  throws SAXException

Specified by:
  `endCDATA` in interface `LexicalHandler`
Throws:
  `SAXException`

#### comment

    public void comment(char[] ch,
                        int start,
                        int length)
                 throws SAXException

Specified by:
  `comment` in interface `LexicalHandler`
Throws:
  `SAXException`